import os
import commands
import string
from frontstage import *
from matools import *
from systeminfo import *
#Tonga venderID:deviceID
tongaID="1002:6929"

#p2p bridge class 0604
bdclass="0604"

#get byte(type str) from cfg_space by given bdf and offset
def pcigetbyte_str(cfg_space,bdf,offset):
    #find bdf in pci config space
    index=cfg_space.find(bdf)
    if index < 0 :
        return -1;
    start=cfg_space[index:]
    #calculate the line offset from the given offset
    #discard the first line which introduce the device name
    line_off=int(offset / 16) + 1
    #calculate the byte offset in the line
    #discard the first field which is the offset number, change it to a number
    byte_off=int(offset % 16) + 1
    lineno=0
    for line in start.split("\n") :
        if lineno < line_off:
            lineno += 1;
            continue;
        else :

            return line.split(" ")[byte_off]

#get word(int)
def pcigetword_int(cfg_space,bdf,offset):
    return int(pcigetbyte_str(cfg_space,bdf,offset+1),16) << 8 | int(pcigetbyte_str(cfg_space,bdf,offset),16)

def check_pciholes(vmlist, pcihole_start, pcihole_end, arg):
    for vm in vmlist:
        
        if bool(arg == "add") ^ bool(int(execcmd("grep \"pciHole.start = \\\"" + '%d'%pcihole_start + "\\\"\" " + vm.vm_vmxpath + " | wc -l")) and int(execcmd("grep \"pciHole.end = \\\"" + '%d'%pcihole_end  + "\\\"\" " + vm.vm_vmxpath + " | wc -l"))):
            return True
                
    
    if arg == "add":
        print "PCI Hole settings already exist on all eligible VMs."
    else:
        print "No PCI Hole settings to remove."
    return False
    
if __name__=='__main__':
    #all bridges, tongas, and pci configuration space
    bridge_bdf=execcmd("lspci -n | grep \"%s\" | cut -d \" \" -f 1" %(bdclass))
    tonga_bdf=execcmd("lspci -n | grep \"%s\" | cut -d \" \" -f 1" %(tongaID))
    pci_cfg_space=execcmd("lspci -e")

    min_membase=0xffffffff
    max_memlimit=0

    bridge2bus_bdf={}

    #mark all bridges with its subbus
    for line in bridge_bdf.split("\n"):
        #get its subbus
        subbus = pcigetbyte_str(pci_cfg_space,line,0x19)
        #add it to dict bridge2bus_bdf[subbus]=bdf of the bridge
        bridge2bus_bdf[subbus] = line

    #enum all tonga cards
    for line in tonga_bdf.split("\n"):
        #get its bus
        bus = line.split(":")[1]
        #for membase,the lower 20bit is assumed as 0; for memlimit,the lower 20bit is assumed as 1
        membase=(pcigetword_int(pci_cfg_space,bridge2bus_bdf[bus],0x20) << 16 ) & 0xfff00000;
        memlimit=(pcigetword_int(pci_cfg_space,bridge2bus_bdf[bus],0x22) << 16 ) | 0x000fffff;
        #merge it
        min_membase=membase if membase < min_membase else min_membase
        max_memlimit=memlimit if memlimit > max_memlimit else max_memlimit
        #becase the lower 20bit of memlimit is all 1, plus 1 and shift its number to get the true limitation

    pcihole_start=min(((min_membase >> 20) / 512 * 512), 2048)
    pcihole_end=max(((((max_memlimit+1) >> 20) + 511)/512*512), 4096)
    print "pciHole.start = %d\npciHole.end = %d" %(pcihole_start,pcihole_end)
	
    
    #if find a range,then write this range to all of the VMs if not in test mode
    if min_membase != 0xffffffff and max_memlimit != 0:
        arg = sys.argv[1]
        srv = ServerInfo()
        srv.Init()
        options = dict()
        ParseNameFile("vms.cfg", options)
        vmlist = GetVMList(options, srv)
        if len(vmlist) == 0:
            print "There is no eligible VM, exit"
            sys.exit()
        print "Eligible VMs:"
        for vm in vmlist:
            print vm.vm_name
        if check_pciholes(vmlist, pcihole_start, pcihole_end, arg):
            if arg == "add":
                question = "PCI Hole settings will be added to these VMs"
            else:
                question = "PCI Hole settings will be removed from these VMs"
            yesno=None
            while yesno not in ("y","Y","") and yesno not in ("n","N"):
                yesno=raw_input("%s. Is this OK?[Y/N]"%(question))
            if yesno in ("n","N"):
                print "User Exit"
                sys.exit()
            #sed -i "/pciHole.\(start\|end\|dynStart\)/d" "$vm"
            print "\nModifying PCI Hole settings on all eligible VMs. This may take a while........"
            for vm in vmlist:
                #delete old configurations, if exist
                execcmd("sed -i \"/pciHole.\(start\|end\|dynStart\)/d\" " + vm.vm_vmxpath)
                #execcmd("sed -i -e \"s/pciHole\.end.*//g\" -e \"/^$/d\" " + vm.vm_vmxpath)
                #write new configurations to the file
                if arg == "add":
                    execcmd("echo pciHole.start = \\\""+ "%d"%pcihole_start +"\\\" >> " + vm.vm_vmxpath)
                    execcmd("echo pciHole.end = \\\""+ "%d"%pcihole_end +"\\\" >> " + vm.vm_vmxpath)

            print "\nCompleted\n"
